/* -*-C-*-
*******************************************************************************
*
* File:         trunc.c
* RCS:          $Header: $
* Description:  truncate the first n bytes from a file
* Author:       Heino Gutschmidt
* Created:      Thu Apr 24 12:22:32 1997
* Modified:     Thu Apr 24 13:08:53 1997 (Heino Gutschmidt) hgu@caliban.informatik.tu-chemnitz.de
* Language:     C
* Package:      N/A
* Status:       Experimental (Do Not Distribute)
*
* (C) Copyright 1997, Heino Gutschmidt, all rights reserved.
*
*******************************************************************************
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define BUF_SIZE 1024
#define DEFAULT_TRUNC 32

int main(int argc, char** argv)
{
  char buffer[BUF_SIZE];
  int truncBytes;
  int count;
  int bytes;

  if (argc > 1)
  {
    if (strcmp(argv[1], "-b") == 0 && argc == 3)
      truncBytes = atoi(argv[2]);
    else
    {
      printf("Truncate the first n bytes from stdin and write the remaining\n");
      printf("bytes to stdout (default is n = 32).\n");
      printf("Usage: %s [-b bytes]\n\n", argv[0]);
      return(1);
    }
  }
  else
    truncBytes = DEFAULT_TRUNC;
  
  count = 0;  
  while(!feof(stdin))
  {
    bytes = fread(buffer, sizeof(char), 1024, stdin);
    if (count + bytes <= truncBytes)
    {
      count += bytes;
      continue;
    }

    if (count <= truncBytes)
    {
      fwrite(&buffer[truncBytes - count], sizeof(char),
	     bytes - (truncBytes - count), stdout);
      count += bytes;
    }
    else
      fwrite(buffer, sizeof(char), bytes, stdout);
  }
  
  return(0);
}
